include:
  - project: computing/gitlab-ci-templates
    file: python.yml
  - project: computing/gitlab-ci-templates
    file: workflow/sccb.yml

stages:
  - build
  - test
  - deploy

# Build Python packages
build:
  extends: .python:build
  stage: build

# Test Python packages
.test:
  extends: .python:pytest
  stage: test
  variables:
    GIT_STRATEGY: none
  needs:
    - build
  before_script:
    - tar --strip-components 1 -xf *.tar.gz
    - python -m pip install pytest-cov pytest-runner -r requirements.txt
  script:
    - python setup.py test --addopts='-vv -s --cov --cov-report=html --cov-report=term --junitxml=junit.xml'
  artifacts:
    paths:
      - htmlcov
    expire_in: 1 day

test:python3.9:
  extends: .test
  image: python:3.9

test:python3.10:
  extends: .test
  image: python:3.10

test:python3.11:
  extends: .test
  image: python:3.11

# Run code lint
lint:
  extends: .python:flake8
  stage: test

# SCCB request
sccb:
  stage: deploy

# Publish coverage
pages:
  stage: deploy
  script:
    - mv htmlcov public/
  artifacts:
    paths:
      - public
    expire_in: 30 days
  needs:
    - test:python3.9
  only:
    - master

# Upload package to PyPI.
# Place your PyPI API token in the repository's GitLab CI secrets.
pypi:
  stage: deploy
  image: python:slim
  variables:
    GIT_STRATEGY: none
  script:
    - pip install twine
    - twine upload --username __token__ --password $PYPI_API_TOKEN *.tar.* *.whl
  needs:
    - build
  only:
    - tags@emfollow/ligo-followup-advocate
